/* Process model C form file: cdpd_mes_mac_m.pr.c */
/* Portions of this file copyright 1992-2003 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
const char cdpd_mes_mac_m_pr_c [] = "MIL_3_Tfile_Hdr_ 100A 30A op_runsim 7 403E68A6 403E68A6 1 zeus saviol 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 90b 2                                                                                                                                                                                                                                                                                                                                                                                                             ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>



/* Header Block */

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "math.h"

/* Define constants. */
#define NIL					0
#define MAX_ENTRANCE_DELAY	35
#define MIN_COUNT			16  /* 2^4 */
#define MAX_COUNT			256 /* 2^8 */
#define MIN_IDLE_TIME		0 /*0.0313*/
#define	MAX_TX_ATTEMPTS		13
//#define	MAX_DELAY_TIME		92.0
//#define	MAX_BUSY_WAIT_TIME	200.0
#define	MAX_BLOCKS			64
#define MAX_BURST_SIZE		24192
//#define	FREQ_SEPARATION		0.63	
//#define	BLOCKED				0
#define IDLE				1
#define BUSY				0
#define FAILURE				1
#define SUCCESS 			0

/* Define the mininum time slot in CDPD */
#define MICROSLOT			0.00313
#define TX_TIME				0.055
#define WAIT_TIME			0.2191

/* Define interrupt codes. */
#define	IDLE_CODE			0
#define	BUSY_CODE			1
#define BLOCKED_CODE		2
#define	DC_CHECK_CODE		3
#define CHECK_CODE			4
#define	DECODE_SUCCESS_CODE	5
#define DECODE_FAIL_CODE	6
#define ST_IDLE_CODE		7


/* Define Data Streams. */
#define	GEN_INSTRM			0
#define	FWD_INSTRM			1
#define	RVS_OUTSTRM			0

/* Define Interrupt Streams */
#define XMIT_BUSY_STAT		0
#define CHAN_BIS_STAT		1
#define CHAN_DECODE_STAT	2

/* Define States */
#define ST_IDLE 			0
#define ST_BIS_CHECK 		1
#define ST_SEND 			2	
#define ST_DECODE_WAIT		3
#define ST_DEFER			4
#define	ST_BACKOFF			5
#define ST_BLOCK			6


/* Define process model transitions. */

#define	CALL_BLOCKED	(next_state == ST_BLOCK)
#define	SEND			(next_state == ST_SEND)
#define WAIT			(next_state == ST_DEFER)
#define DC_CHECK		(next_state == ST_DECODE_WAIT)
#define DECODE_SUCCESS	(next_state == ST_IDLE)
#define DECODE_FAIL		(next_state == ST_BACKOFF)
#define END_SIMULATION	(op_intrpt_type () == OPC_INTRPT_ENDSIM)
//#define	RCVD_FWD		(op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == FWD_INSTRM)
//#define	PKT_ARV		    (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == GEN_INSTRM)
//#define	CHECK_DECODE    (op_intrpt_type () == OPC_INTRPT_SELF && op_intrpt_code () == CHECK_CODE)

//#define	CALL_BLOCKED	((nbusy >= MAXBUSY)||(nblock>=MAX_ACCESS))
//#define	SEND			(op_intrpt_type () == OPC_INTRPT_SELF && op_intrpt_code () == IDLE_CODE)
//#define WAIT			(op_intrpt_type () == OPC_INTRPT_SELF && op_intrpt_code () == BUSY_CODE)
//#define BLOCKED_WAIT	(op_intrpt_type () == OPC_INTRPT_SELF && op_intrpt_code () == BLOCKED_CODE)
//#define BUSY			(bis==0)
//#define IDLE			(bis==1)
/*
#define DECODE_FAIL		(op_intrpt_type () == OPC_INTRPT_SELF && op_intrpt_code () == DECODE_FAIL_CODE)
#define DECODE_SUCCESS	(op_intrpt_type () == OPC_INTRPT_SELF && op_intrpt_code () == DECODE_SUCCESS_CODE)
*/
//#define DC_CHECK		(op_intrpt_type () == OPC_INTRPT_SELF && op_intrpt_code () == DC_CHECK_CODE)

FILE					*fp;
extern					Objid	mdbs_id;
//#define NO_INTRPT		!(SEND||WAIT||BLOCKED_WAIT)
/*
#define SUBQ_EMPTY		(op_subq_empty(0)==OPC_TRUE)
*/
#define SUBQ_EMPTY		(op_subq_stat(0, OPC_QSTAT_PKSIZE)==0)
//#define PKT_SENT		(packet_sent)

static void 			int_show();

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int	                    		bis;
	int	                    		blocks;
	int	                    		tx_attempt;
	Objid	                  		my_id;
	Packet*	                		frmptr;
	Distribution*	          		delay_dist_ptr;
	Distribution*	          		busy_dist_ptr;
	Objid	                  		monitor_id;
	Objid	                  		node_id;
	int	                    		blk_counter;
	int	                    		frame_sent;
	Stathandle	             		income_frm_count_stathandle;
	int	                    		income_frm_count;
	Stathandle	             		output_frm_count_stathandle;
	int	                    		output_frm_count;
	int	                    		bk_count;
	int	                    		next_state;
	int	                    		burst_size;
	int	                    		next_pos;
	Stathandle	             		burst_size_stathandle;
	int	                    		decode;
	Sbhandle	               		seg_buf_ptr;
	int	                    		frame_label;
	double	                 		seg_buf_size;
	Packet *	               		blk_ptr;
	int	                    		blk_size;
	int	                    		first_frame;
	Stathandle	             		blocks_stathandle;
	Stathandle	             		frm_cnt_stathandle;
	int	                    		tot_frm_cnt;
	int	                    		sent_size;
	int	                    		blks_sent;
	} cdpd_mes_mac_m_state;

#define pr_state_ptr            		((cdpd_mes_mac_m_state*) (OP_SIM_CONTEXT_PTR->mod_state_ptr))
#define bis                     		pr_state_ptr->bis
#define blocks                  		pr_state_ptr->blocks
#define tx_attempt              		pr_state_ptr->tx_attempt
#define my_id                   		pr_state_ptr->my_id
#define frmptr                  		pr_state_ptr->frmptr
#define delay_dist_ptr          		pr_state_ptr->delay_dist_ptr
#define busy_dist_ptr           		pr_state_ptr->busy_dist_ptr
#define monitor_id              		pr_state_ptr->monitor_id
#define node_id                 		pr_state_ptr->node_id
#define blk_counter             		pr_state_ptr->blk_counter
#define frame_sent              		pr_state_ptr->frame_sent
#define income_frm_count_stathandle		pr_state_ptr->income_frm_count_stathandle
#define income_frm_count        		pr_state_ptr->income_frm_count
#define output_frm_count_stathandle		pr_state_ptr->output_frm_count_stathandle
#define output_frm_count        		pr_state_ptr->output_frm_count
#define bk_count                		pr_state_ptr->bk_count
#define next_state              		pr_state_ptr->next_state
#define burst_size              		pr_state_ptr->burst_size
#define next_pos                		pr_state_ptr->next_pos
#define burst_size_stathandle   		pr_state_ptr->burst_size_stathandle
#define decode                  		pr_state_ptr->decode
#define seg_buf_ptr             		pr_state_ptr->seg_buf_ptr
#define frame_label             		pr_state_ptr->frame_label
#define seg_buf_size            		pr_state_ptr->seg_buf_size
#define blk_ptr                 		pr_state_ptr->blk_ptr
#define blk_size                		pr_state_ptr->blk_size
#define first_frame             		pr_state_ptr->first_frame
#define blocks_stathandle       		pr_state_ptr->blocks_stathandle
#define frm_cnt_stathandle      		pr_state_ptr->frm_cnt_stathandle
#define tot_frm_cnt             		pr_state_ptr->tot_frm_cnt
#define sent_size               		pr_state_ptr->sent_size
#define blks_sent               		pr_state_ptr->blks_sent

/* These macro definitions will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#if defined (OPD_PARALLEL)
#  define FIN_PREAMBLE_DEC	cdpd_mes_mac_m_state *op_sv_ptr; OpT_Sim_Context * tcontext_ptr;
#  define FIN_PREAMBLE_CODE	\
		if (VosS_Mt_Perform_Lock) \
			VOS_THREAD_SPECIFIC_DATA_GET (VosI_Globals.simi_mt_context_data_key, tcontext_ptr, SimT_Context *); \
		else \
			tcontext_ptr = VosI_Globals.simi_sequential_context_ptr; \
		op_sv_ptr = ((cdpd_mes_mac_m_state *)(tcontext_ptr->mod_state_ptr));
#else
#  define FIN_PREAMBLE_DEC	cdpd_mes_mac_m_state *op_sv_ptr;
#  define FIN_PREAMBLE_CODE	op_sv_ptr = pr_state_ptr;
#endif


/* Function Block */


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ };
#endif
void int_show()
{
	fprintf(fp, "The interupt is %s\n", op_intrpt_type());
}

/* End of Function Block */

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void cdpd_mes_mac_m (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype cdpd_mes_mac_m_init (int * init_block_ptr);
	VosT_Address cdpd_mes_mac_m_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype, int);
	void cdpd_mes_mac_m_diag (OP_SIM_CONTEXT_ARG_OPT);
	void cdpd_mes_mac_m_terminate (OP_SIM_CONTEXT_ARG_OPT);
	void cdpd_mes_mac_m_svar (void *, const char *, void **);


	VosT_Fun_Status Vos_Define_Object (VosT_Obtype * _op_obst_ptr, const char * _op_name, unsigned int _op_size, unsigned int _op_init_obs, unsigned int _op_inc_obs);
	VosT_Address Vos_Alloc_Object_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype _op_ob_hndl);
	VosT_Fun_Status Vos_Poolmem_Dealloc_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Address _op_ob_ptr);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
cdpd_mes_mac_m (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (cdpd_mes_mac_m ());
	if (1)
		{
		double		wait_time;
		Packet		*cp_frame;
		Packet		*new_frame;
		int 		frm_size;
		int			remaining_bits;
		int			quit_send;


		FSM_ENTER ("cdpd_mes_mac_m")

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "cdpd_mes_mac_m [init enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [init enter execs]", state0_enter_exec)
				{
				/* Schedule a self intrpt to mark the end of auto addressing .*/
				op_intrpt_schedule_self (0.0,0);
				
				/* Initialize counters */
				blk_counter=0;
				
				/* Initialize flags */
				blk_size = 0;
				frame_label=0;
				seg_buf_size=0;
				frame_sent=0;
				income_frm_count=0;
				output_frm_count=0;
				bk_count = MIN_COUNT;
				next_state = ST_IDLE;
				
				/* Register local statistics */
				income_frm_count_stathandle=op_stat_reg ("income frame count", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				output_frm_count_stathandle=op_stat_reg ("output frame count", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				burst_size_stathandle=op_stat_reg ("burst size", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				blocks_stathandle=op_stat_reg ("block burst", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				seg_buf_ptr = op_sar_buf_create(OPC_SAR_BUF_TYPE_SEGMENT, OPC_SAR_BUF_OPT_DEFAULT);
				
				tot_frm_cnt = 0;
				frm_cnt_stathandle=op_stat_reg ("frame count", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "cdpd_mes_mac_m [init exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [init exit execs]", state0_exit_exec)
				{
				/* Here we do all initialization necessary.  Appropriate 	*/
				/* PDF's are loaded, statistics are initialized, object 	*/
				/* id's are gotten, etc. 									*/
				/* Set up the distributions for the retry timers. 			*/
				/* Will draw a value off the delay_dist_ptr when first 		*/
				/* setting up a call and when access timeout occurs to 		*/
				/* schedule a retry. Will use the busy_dist_ptr when 		*/
				/* the busy-idle status bit is "busy". 						*/
				//delay_dist_ptr = op_dist_load ("uniform", 0.0, MAX_DELAY_TIME);
				//busy_dist_ptr = op_dist_load ("uniform", 0.0, MAX_BUSY_WAIT_TIME);
				
				/* Initially set bis = 1 (idle). */
				bis = IDLE;
				
				/* Initialize the number of calls blocked to 0. */
				tx_attempt = 0;
				
				/* Obtain the object ID for the channel monitor */							
				node_id = op_topo_parent (op_id_self ());
				monitor_id = op_id_from_name (node_id, OPC_OBJTYPE_PROC, "channel_monitor");
				
				
				
				}
				FSM_PROFILE_SECTION_OUT (state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (3, state3_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (defer) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, "defer", state1_enter_exec, "cdpd_mes_mac_m [defer enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [defer enter execs]", state1_enter_exec)
				{
				/* There is a limit to how many times we can check the bis	*/
				/* before giving up on the call.  If we haven't yet exceeded*/
				/* that limit, calculate a random backoff- wait_time 		*/
				/* and set a self interrupt to recheck the bis at that time.*/
				/* If we have reached the limit of bis checks, we don't do	*/
				/* annything and will transition to idle and give up on the	*/
				/* attempted call.*/
				
				//bis_id = op_id_from_name (mdbs_id, OPC_OBJTYPE_PROC, "bis_set");
				//op_ima_obj_attr_get (bis_id, "bis", &bis);
				if ((op_intrpt_type()==OPC_INTRPT_STAT) && (op_intrpt_stat() == CHAN_BIS_STAT))
				{
					bis = op_stat_local_read(CHAN_BIS_STAT);
				}
				
				if((op_intrpt_type()==OPC_INTRPT_STRM)&& (op_intrpt_strm()==GEN_INSTRM))
				{
						if(!((new_frame=op_pk_get(GEN_INSTRM))==NIL))
						{
								op_subq_pk_insert(0, new_frame, OPC_QPOS_TAIL);
								income_frm_count=income_frm_count+1;
								op_stat_write(income_frm_count_stathandle, income_frm_count);
						}
				}
				else if (op_intrpt_type () == OPC_INTRPT_SELF && op_intrpt_code () == BUSY_CODE)
				{
				//	bis = 1;
				
					if (tx_attempt < MAX_TX_ATTEMPTS)
					{
						if ((bis == IDLE) && (op_stat_local_read(0) == 0))
						{	
							tx_attempt = 0;
							op_intrpt_schedule_self (op_sim_time () + WAIT_TIME, IDLE_CODE);
							next_state = ST_SEND;
							blocks = 0;
							frame_sent = 0;
						}
				
						else // if (bis == 0)
						{
							wait_time = op_dist_uniform(MAX_ENTRANCE_DELAY);
							op_intrpt_schedule_self (op_sim_time ()+(wait_time*MICROSLOT), BUSY_CODE);
							tx_attempt++;
						}
					}
					else
						next_state = ST_BLOCK;
				}
				}
				FSM_PROFILE_SECTION_OUT (state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,"cdpd_mes_mac_m")


			/** state (defer) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "defer", "cdpd_mes_mac_m [defer exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [defer exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state1_exit_exec)


			/** state (defer) transition processing **/
			FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [defer trans conditions]", state1_trans_conds)
			FSM_INIT_COND (SEND)
			FSM_TEST_COND (CALL_BLOCKED)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("defer")
			FSM_PROFILE_SECTION_OUT (state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 7, state7_enter_exec, ;, "SEND", "", "defer", "send")
				FSM_CASE_TRANSIT (1, 5, state5_enter_exec, ;, "CALL_BLOCKED", "", "defer", "block")
				FSM_CASE_TRANSIT (2, 1, state1_enter_exec, ;, "default", "", "defer", "defer")
				}
				/*---------------------------------------------------------*/



			/** state (backoff) enter executives **/
			FSM_STATE_ENTER_UNFORCED (2, "backoff", state2_enter_exec, "cdpd_mes_mac_m [backoff enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [backoff enter execs]", state2_enter_exec)
				{
				/* There is a limit to how many times we can check the bis	*/
				/* before giving up on the call.  If we haven't yet exceeded*/
				/* that limit, calculate a random backoff- wait_time 		*/
				/* and set a self interrupt to recheck the bis at that time.*/
				/* If we have reached the limit of bis checks, we don't do	*/
				/* annything and will transition to idle and give up on the	*/
				/* attempted call.											*/
				if ((op_intrpt_type()==OPC_INTRPT_STAT) && (op_intrpt_stat() == CHAN_BIS_STAT))
				{
					bis = op_stat_local_read(CHAN_BIS_STAT);
				}
				/*if ((op_intrpt_type()==OPC_INTRPT_STAT) && (op_intrpt_stat() == CHAN_DECODE_STAT))
				{
					decode = op_stat_local_read(CHAN_DECODE_STAT);
				}*/
				else if((op_intrpt_type()==OPC_INTRPT_STRM)&& (op_intrpt_strm()==GEN_INSTRM))
				{
						if(!((new_frame=op_pk_get(GEN_INSTRM))==NIL))
						{
								op_subq_pk_insert(0, new_frame, OPC_QPOS_TAIL);
								income_frm_count=income_frm_count+1;
								op_stat_write(income_frm_count_stathandle, income_frm_count);
						}
				}
				else if (op_intrpt_type()==OPC_INTRPT_SELF)
				{
					//bis_id = op_id_from_name (mdbs_id, OPC_OBJTYPE_PROC, "bis_set");
					//op_ima_obj_attr_get (bis_id, "bis", &bis);
				
				//	bis = 1;
				
					if (tx_attempt <= MAX_TX_ATTEMPTS)
					{
						if (bis == IDLE)
						{
							op_intrpt_schedule_self (op_sim_time () + WAIT_TIME, IDLE_CODE);
							next_state = ST_SEND;
							bk_count = MIN_COUNT;
							frame_sent = 0;
							blocks = 0;
						}
				
						else
						{
							wait_time = op_dist_uniform(bk_count-1);
							op_intrpt_schedule_self (op_sim_time ()+(wait_time*MICROSLOT), BLOCKED_CODE);
							tx_attempt++;
							if (bk_count < MAX_COUNT)
							{
								bk_count = bk_count*2;
							}
						}
					}
					else
						next_state = ST_BLOCK;
				}
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (5,"cdpd_mes_mac_m")


			/** state (backoff) exit executives **/
			FSM_STATE_EXIT_UNFORCED (2, "backoff", "cdpd_mes_mac_m [backoff exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [backoff exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state2_exit_exec)


			/** state (backoff) transition processing **/
			FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [backoff trans conditions]", state2_trans_conds)
			FSM_INIT_COND (CALL_BLOCKED)
			FSM_TEST_COND (SEND)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("backoff")
			FSM_PROFILE_SECTION_OUT (state2_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 5, state5_enter_exec, ;, "CALL_BLOCKED", "", "backoff", "block")
				FSM_CASE_TRANSIT (1, 7, state7_enter_exec, ;, "SEND", "", "backoff", "send")
				FSM_CASE_TRANSIT (2, 2, state2_enter_exec, ;, "default", "", "backoff", "backoff")
				}
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (3, "idle", state3_enter_exec, "cdpd_mes_mac_m [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [idle enter execs]", state3_enter_exec)
				{
				/* If a Packet arrives */
				if((op_intrpt_type()==OPC_INTRPT_STRM)&& (op_intrpt_strm()==GEN_INSTRM))
				{
				
				/* Get the Packet from the incoming stream */
						frmptr=op_pk_get(GEN_INSTRM);
				
				/* Insert the Packet to the queue */
						if (op_subq_pk_insert (0, frmptr, OPC_QPOS_TAIL) != OPC_QINS_OK)
				    	{
						    op_pk_destroy (frmptr);
						}
				
				/* Update the local statistic */		
						income_frm_count=income_frm_count+1;
						op_stat_write(income_frm_count_stathandle, income_frm_count);
				}
				else if ((op_intrpt_type()==OPC_INTRPT_STAT) && (op_intrpt_stat() == CHAN_BIS_STAT))
				{
					bis = op_stat_local_read(CHAN_BIS_STAT);
				}
				}
				FSM_PROFILE_SECTION_OUT (state3_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (7,"cdpd_mes_mac_m")


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (3, "idle", "cdpd_mes_mac_m [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [idle exit execs]", state3_exit_exec)
				{
				
				}
				FSM_PROFILE_SECTION_OUT (state3_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [idle trans conditions]", state3_trans_conds)
			FSM_INIT_COND (!SUBQ_EMPTY&&!END_SIMULATION)
			FSM_TEST_COND (END_SIMULATION)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT (state3_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 4, state4_enter_exec, ;, "!SUBQ_EMPTY&&!END_SIMULATION", "", "idle", "bis_check")
				FSM_CASE_TRANSIT (1, 6, state6_enter_exec, ;, "END_SIMULATION", "", "idle", "end_sim")
				FSM_CASE_TRANSIT (2, 3, state3_enter_exec, ;, "default", "", "idle", "idle")
				}
				/*---------------------------------------------------------*/



			/** state (bis_check) enter executives **/
			FSM_STATE_ENTER_FORCED (4, "bis_check", state4_enter_exec, "cdpd_mes_mac_m [bis_check enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [bis_check enter execs]", state4_enter_exec)
				{
				/* Retrive the first Packet from the head of queue */
				//pkptr=op_subq_pk_remove(0, OPC_QPOS_HEAD);
				
				/* Check the channel busy/idle status */
				//bis_id = op_id_from_name (mdbs_id, OPC_OBJTYPE_PROC, "bis_set");
				//op_ima_obj_attr_get (bis_id, "bis", &bis);
				
				//bis = 1;
				tx_attempt = 0;
				
				/* If the channel is idle, schedule a self interupt to send out packet*/
				if ((bis==IDLE) && (op_stat_local_read(XMIT_BUSY_STAT) == 0))
				{
					op_intrpt_schedule_self (op_sim_time(), IDLE_CODE);
					next_state = ST_SEND;
					frame_sent = 0;
				}
				else /* Making sure that there is a initial delay on busy */
				{
					wait_time = op_dist_uniform(MAX_ENTRANCE_DELAY);
					op_intrpt_schedule_self (op_sim_time ()+(wait_time*MICROSLOT), BUSY_CODE);
					next_state = ST_DEFER;
					tx_attempt++;
				}
				
				
				
				
				/* If the channel is busy, wait for a random time and try to retransmit */
				//else if (bis ==0)
				//{
					/*op_intrpt_schedule_self (op_sim_time (), BUSY_CODE);*/
					
				//}
				}
				FSM_PROFILE_SECTION_OUT (state4_enter_exec)

			/** state (bis_check) exit executives **/
			FSM_STATE_EXIT_FORCED (4, "bis_check", "cdpd_mes_mac_m [bis_check exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [bis_check exit execs]", state4_exit_exec)
				{
				
				}
				FSM_PROFILE_SECTION_OUT (state4_exit_exec)


			/** state (bis_check) transition processing **/
			FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [bis_check trans conditions]", state4_trans_conds)
			FSM_INIT_COND (WAIT)
			FSM_TEST_COND (SEND)
			FSM_TEST_LOGIC ("bis_check")
			FSM_PROFILE_SECTION_OUT (state4_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;, "WAIT", "", "bis_check", "defer")
				FSM_CASE_TRANSIT (1, 7, state7_enter_exec, ;, "SEND", "", "bis_check", "send")
				}
				/*---------------------------------------------------------*/



			/** state (block) enter executives **/
			FSM_STATE_ENTER_FORCED (5, "block", state5_enter_exec, "cdpd_mes_mac_m [block enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [block enter execs]", state5_enter_exec)
				{
				blk_counter++;
				//op_subq_flush(0);
				
				op_intrpt_schedule_self(op_sim_time(), CHECK_CODE);
				}
				FSM_PROFILE_SECTION_OUT (state5_enter_exec)

			/** state (block) exit executives **/
			FSM_STATE_EXIT_FORCED (5, "block", "cdpd_mes_mac_m [block exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [block exit execs]", state5_exit_exec)
				{
				
				}
				FSM_PROFILE_SECTION_OUT (state5_exit_exec)


			/** state (block) transition processing **/
			FSM_TRANSIT_FORCE (3, state3_enter_exec, ;, "default", "", "block", "idle")
				/*---------------------------------------------------------*/



			/** state (end_sim) enter executives **/
			FSM_STATE_ENTER_FORCED (6, "end_sim", state6_enter_exec, "cdpd_mes_mac_m [end_sim enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [end_sim enter execs]", state6_enter_exec)
				{
				
				}
				FSM_PROFILE_SECTION_OUT (state6_enter_exec)

			/** state (end_sim) exit executives **/
			FSM_STATE_EXIT_FORCED (6, "end_sim", "cdpd_mes_mac_m [end_sim exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [end_sim exit execs]", state6_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state6_exit_exec)


			/** state (end_sim) transition processing **/
			FSM_TRANSIT_FORCE (3, state3_enter_exec, ;, "default", "", "end_sim", "idle")
				/*---------------------------------------------------------*/



			/** state (send) enter executives **/
			FSM_STATE_ENTER_UNFORCED (7, "send", state7_enter_exec, "cdpd_mes_mac_m [send enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [send enter execs]", state7_enter_exec)
				{
				/* First entry into the state - sending first block */
				if ((op_intrpt_type() == OPC_INTRPT_SELF) && (op_intrpt_code() == IDLE_CODE))
				{
					quit_send = 0;
					blk_size = 0;
					first_frame = 0;
					blocks = 0;
					blks_sent = 0;
				
				    /* sending preamble and synchronization word */
				    frmptr = op_pk_create_fmt("cdpd_reverse_packet1");
					op_pk_send(frmptr, RVS_OUTSTRM);
				
					/* getting first data frame */
					frmptr = op_subq_pk_access(0, OPC_QPOS_HEAD);
					cp_frame = op_pk_copy(frmptr);
					frm_size = op_pk_total_size_get(cp_frame);
					next_pos = 1;
					frame_sent++;
				
					op_stat_write(frm_cnt_stathandle, frame_sent);
				
					/* Insertion of the first frame into the Segmentation Buffer */
					op_sar_segbuf_pk_insert(seg_buf_ptr, cp_frame, frame_label++);
					cp_frame = op_pk_create_fmt("cdpd_frm_flag_seq");
					op_sar_segbuf_pk_insert(seg_buf_ptr, cp_frame, frame_label++);	
					seg_buf_size = op_sar_buf_size(seg_buf_ptr);
					
					/* Insertion of additional frames into the Segmentation Buffer */
					while (quit_send == 0)
					{
						frmptr=op_subq_pk_access(0, next_pos);
						if (frmptr != NIL)
						{
							cp_frame = op_pk_copy(frmptr);
							frm_size = op_pk_total_size_get(cp_frame);
							remaining_bits = 18038 - seg_buf_size;
							if (remaining_bits >= (frm_size + 10))
							{
								op_sar_segbuf_pk_insert(seg_buf_ptr, cp_frame, frame_label++);
								cp_frame = op_pk_create_fmt("cdpd_frm_flag_seq");
								op_sar_segbuf_pk_insert(seg_buf_ptr, cp_frame, frame_label++);	
								frame_sent++;
								op_stat_write(frm_cnt_stathandle, frame_sent);
								next_pos++;
							}
							else
								quit_send = 1;
						}
						else
							quit_send = 1;
						seg_buf_size = op_sar_buf_size(seg_buf_ptr);
					}
					/* Max Data size for first block is 274 bits due to 8-bit color code
					   if frame size is too small then grab more frames from queue into
					   segmentation buffer until it's above the minimum size or the queue is
					   empty a 10-bit delimiter called frame flag is added after each frame
					   as per spec */
					blk_size = 274;
				
					blk_ptr = op_sar_srcbuf_seg_remove(seg_buf_ptr, blk_size);
					burst_size = op_pk_total_size_get(blk_ptr);
					op_stat_write(burst_size_stathandle, burst_size);
					cp_frame = op_pk_create_fmt("cdpd_reverse_packet2");
					op_pk_nfd_set(cp_frame, "MDLP Data", blk_ptr);
					op_pk_send (cp_frame, RVS_OUTSTRM);
					seg_buf_size = op_sar_buf_size(seg_buf_ptr);
				}
				
				else if ((op_intrpt_type()==OPC_INTRPT_STAT) && (frame_sent > 0))
				{
					if (op_intrpt_stat() == CHAN_DECODE_STAT)
					{
						decode = op_stat_local_read(CHAN_DECODE_STAT);
						if (decode == FAILURE)
						{
							bk_count = MIN_COUNT;
							wait_time = op_dist_uniform(bk_count-1);
							op_intrpt_schedule_self (op_sim_time ()+(wait_time*MICROSLOT), DECODE_FAIL_CODE);
							next_state = ST_BACKOFF;
							tx_attempt++;
							// no need to check for MAX_COUNT here since we know we're using MIN_COUNT 
							bk_count = bk_count*2;
							// Clear the whole segmentation buffer so that transmission start anew on the next try.
							seg_buf_size = op_sar_buf_size(seg_buf_ptr);
							if (seg_buf_size > 0)
								op_sar_srcbuf_bits_flush(seg_buf_ptr, 0, seg_buf_size);
						}
					}
				
				
					/* When the transmitter is no longer busy, send additional frames
					   if maximum burst size is not reached 
					   if maximum size is reached then go to decode_wait state
					   if no additional packets are in the queue then go to decode_wait state */
					else if (op_intrpt_stat() == XMIT_BUSY_STAT) //downward edge (on->off) trigger only
					{
						// block sent - set up decode timer
						blocks++;
						op_stat_write(blocks_stathandle, blocks);
						op_intrpt_schedule_self (op_sim_time() + 9 * MICROSLOT, DC_CHECK_CODE);
						seg_buf_size = op_sar_buf_size(seg_buf_ptr);
				
						if (seg_buf_size <= 0) //all blocks are transmitted
						{
							next_state = ST_DECODE_WAIT;
						}
						else
					    {
							// send another block
							blk_size = 282;
							blk_ptr = op_sar_srcbuf_seg_remove(seg_buf_ptr, blk_size);
							burst_size = burst_size + op_pk_total_size_get(blk_ptr);
							op_stat_write(burst_size_stathandle, burst_size);		
							cp_frame = op_pk_create_fmt("cdpd_reverse_packet2");
							op_pk_nfd_set(cp_frame, "MDLP Data", blk_ptr);
							op_pk_send (cp_frame, RVS_OUTSTRM);
						}
					}
				}
						 
				/* if a decode error is not received 7 microslots after
				   the transmitter has finished transmitting the packet
				   then assume that it's received correctly and remove
				   from queue */
				   
				else if ((op_intrpt_type() == OPC_INTRPT_SELF) && (op_intrpt_code() == DC_CHECK_CODE) && (blocks > blks_sent))
				{
					blks_sent++;
					if (first_frame == 0)
					{
						first_frame = 1;
						sent_size = 274;
					}
					else
						sent_size = sent_size + 282;
					frmptr = op_subq_pk_access(0, OPC_QPOS_HEAD);
					frm_size = op_pk_total_size_get(frmptr);
					while ((frm_size +10) <= sent_size)
					{
						sent_size = sent_size - 10 - frm_size;
						frmptr=op_subq_pk_remove(0, OPC_QPOS_HEAD);
						op_pk_destroy(frmptr);
						frame_sent = frame_sent - 1;
				//		op_stat_write(frm_cnt_stathandle, frame_sent);
						output_frm_count++;
						/* Update the local statistic 'output_pk_count'*/
						op_stat_write(output_frm_count_stathandle, output_frm_count);
						frmptr = op_subq_pk_access(0, OPC_QPOS_HEAD);
						frm_size = op_pk_total_size_get(frmptr);
					}
				}
				// Handle the cases of packet arrival from source during wait
				else if ((op_intrpt_type() == OPC_INTRPT_STRM)&& (op_intrpt_strm() == GEN_INSTRM))
				{
					if(!((new_frame=op_pk_get(GEN_INSTRM))==NIL))
					{
						op_subq_pk_insert(0, new_frame, OPC_QPOS_TAIL);
						income_frm_count=income_frm_count+1;
						op_stat_write(income_frm_count_stathandle, income_frm_count);
					}
				}
				}
				FSM_PROFILE_SECTION_OUT (state7_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (15,"cdpd_mes_mac_m")


			/** state (send) exit executives **/
			FSM_STATE_EXIT_UNFORCED (7, "send", "cdpd_mes_mac_m [send exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [send exit execs]", state7_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state7_exit_exec)


			/** state (send) transition processing **/
			FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [send trans conditions]", state7_trans_conds)
			FSM_INIT_COND (DECODE_FAIL)
			FSM_TEST_COND (DC_CHECK)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("send")
			FSM_PROFILE_SECTION_OUT (state7_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "DECODE_FAIL", "", "send", "backoff")
				FSM_CASE_TRANSIT (1, 8, state8_enter_exec, ;, "DC_CHECK", "", "send", "decode_wait")
				FSM_CASE_TRANSIT (2, 7, state7_enter_exec, ;, "default", "", "send", "send")
				}
				/*---------------------------------------------------------*/



			/** state (decode_wait) enter executives **/
			FSM_STATE_ENTER_UNFORCED (8, "decode_wait", state8_enter_exec, "cdpd_mes_mac_m [decode_wait enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [decode_wait enter execs]", state8_enter_exec)
				{
				if((op_intrpt_type()==OPC_INTRPT_STRM)&& (op_intrpt_strm()==GEN_INSTRM))
				{
						if(!((new_frame=op_pk_get(GEN_INSTRM))==NIL))
						{
								op_subq_pk_insert(0, new_frame, OPC_QPOS_TAIL);
								income_frm_count=income_frm_count+1;
								op_stat_write(income_frm_count_stathandle, income_frm_count);
						}
				}
				else if ((op_intrpt_type() == OPC_INTRPT_SELF) && (op_intrpt_code() == DC_CHECK_CODE))
				{
					blks_sent++;
					if (first_frame == 0)
					{
						first_frame = 1;
						sent_size = 274;
					}
					else
						sent_size = sent_size + 282;
					frmptr = op_subq_pk_access(0, OPC_QPOS_HEAD);
					frm_size = op_pk_total_size_get(frmptr);
					while ((frm_size +10) <= sent_size)
					{
						sent_size = sent_size - 10 - frm_size;
						frmptr = op_subq_pk_remove(0, OPC_QPOS_HEAD);
						op_pk_destroy(frmptr);
						frame_sent = frame_sent - 1;
						output_frm_count++;
						/* Update the local statistic 'output_pk_count'*/
						op_stat_write(output_frm_count_stathandle, output_frm_count);
						frmptr = op_subq_pk_access(0, OPC_QPOS_HEAD);
						if (frmptr != NIL)
							frm_size = op_pk_total_size_get(frmptr);
						else
							sent_size = 0;
					}
					if (blocks == blks_sent)
					{
						op_intrpt_schedule_self(op_sim_time() + MIN_IDLE_TIME, DECODE_SUCCESS_CODE);
					}
					/* Obtain the decoding status */
					//decode_id = op_id_from_name (mdbs_id, OPC_OBJTYPE_PROC, "decode_set");
					//op_ima_obj_attr_get (decode_id, "decode", &decode);
				}
				else if ((op_intrpt_type() == OPC_INTRPT_SELF) && (op_intrpt_code() == DECODE_SUCCESS_CODE))
				{
					op_intrpt_schedule_self(op_sim_time(), ST_IDLE_CODE);
					next_state = ST_IDLE;
				}
				/*else if ((op_intrpt_type()==OPC_INTRPT_STAT) && (op_intrpt_stat() == CHAN_BUS_STAT))
				{
					bis = op_stat_local_read(CHAN_BUS_STAT);
				}*/
				else if ((op_intrpt_type()==OPC_INTRPT_STAT) && (op_intrpt_stat() == CHAN_DECODE_STAT) && (frame_sent > 0))
				{
					decode = op_stat_local_read(CHAN_DECODE_STAT);
					if (decode == FAILURE)
					{
						bk_count = MIN_COUNT;
						wait_time = op_dist_uniform(bk_count-1);
						op_intrpt_schedule_self (op_sim_time ()+(wait_time*MICROSLOT), DECODE_FAIL_CODE);
						next_state = ST_BACKOFF;
						tx_attempt++;
						// no need to check for MAX_COUNT here since we know we're using MIN_COUNT 
						bk_count = bk_count*2;
						// Clear the whole segmentation buffer so that transmission start anew on the next try.
						seg_buf_size = op_sar_buf_size(seg_buf_ptr);
						if (seg_buf_size > 0)
							op_sar_srcbuf_bits_flush(seg_buf_ptr, 0, seg_buf_size);
					}
				}
				else if ((op_intrpt_type()==OPC_INTRPT_STAT) && (op_intrpt_stat() == XMIT_BUSY_STAT))
				{
					// block sent - set up decode timer
					blocks++;
					op_stat_write(blocks_stathandle, blocks);
					op_intrpt_schedule_self (op_sim_time() + 9 * MICROSLOT, DC_CHECK_CODE);
					seg_buf_size = op_sar_buf_size(seg_buf_ptr);
				}
				
				}
				FSM_PROFILE_SECTION_OUT (state8_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (17,"cdpd_mes_mac_m")


			/** state (decode_wait) exit executives **/
			FSM_STATE_EXIT_UNFORCED (8, "decode_wait", "cdpd_mes_mac_m [decode_wait exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [decode_wait exit execs]", state8_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state8_exit_exec)


			/** state (decode_wait) transition processing **/
			FSM_PROFILE_SECTION_IN ("cdpd_mes_mac_m [decode_wait trans conditions]", state8_trans_conds)
			FSM_INIT_COND (DECODE_FAIL)
			FSM_TEST_COND (DECODE_SUCCESS)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("decode_wait")
			FSM_PROFILE_SECTION_OUT (state8_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "DECODE_FAIL", "", "decode_wait", "backoff")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "DECODE_SUCCESS", "", "decode_wait", "idle")
				FSM_CASE_TRANSIT (2, 8, state8_enter_exec, ;, "default", "", "decode_wait", "decode_wait")
				}
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,"cdpd_mes_mac_m")
		}
	}




void
cdpd_mes_mac_m_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	/* No Diagnostic Block */
	}




void
cdpd_mes_mac_m_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__;
#endif

	FIN_MT (cdpd_mes_mac_m_terminate ())

	Vos_Poolmem_Dealloc_MT (OP_SIM_CONTEXT_THREAD_INDEX_COMMA pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in cdpd_mes_mac_m_svar function. */
#undef bis
#undef blocks
#undef tx_attempt
#undef my_id
#undef frmptr
#undef delay_dist_ptr
#undef busy_dist_ptr
#undef monitor_id
#undef node_id
#undef blk_counter
#undef frame_sent
#undef income_frm_count_stathandle
#undef income_frm_count
#undef output_frm_count_stathandle
#undef output_frm_count
#undef bk_count
#undef next_state
#undef burst_size
#undef next_pos
#undef burst_size_stathandle
#undef decode
#undef seg_buf_ptr
#undef frame_label
#undef seg_buf_size
#undef blk_ptr
#undef blk_size
#undef first_frame
#undef blocks_stathandle
#undef frm_cnt_stathandle
#undef tot_frm_cnt
#undef sent_size
#undef blks_sent

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
cdpd_mes_mac_m_init (int * init_block_ptr)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (cdpd_mes_mac_m_init (init_block_ptr))

	Vos_Define_Object (&obtype, "proc state vars (cdpd_mes_mac_m)",
		sizeof (cdpd_mes_mac_m_state), 0, 20);
	*init_block_ptr = 0;

	FRET (obtype)
	}

VosT_Address
cdpd_mes_mac_m_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype obtype, int init_block)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	cdpd_mes_mac_m_state * ptr;
	FIN_MT (cdpd_mes_mac_m_alloc (obtype))

	ptr = (cdpd_mes_mac_m_state *)Vos_Alloc_Object_MT (VOS_THREAD_INDEX_COMMA obtype);
	if (ptr != OPC_NIL)
		ptr->_op_current_block = init_block;
	FRET ((VosT_Address)ptr)
	}



void
cdpd_mes_mac_m_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	cdpd_mes_mac_m_state		*prs_ptr;

	FIN_MT (cdpd_mes_mac_m_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (cdpd_mes_mac_m_state *)gen_ptr;

	if (strcmp ("bis" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->bis);
		FOUT
		}
	if (strcmp ("blocks" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->blocks);
		FOUT
		}
	if (strcmp ("tx_attempt" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->tx_attempt);
		FOUT
		}
	if (strcmp ("my_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->my_id);
		FOUT
		}
	if (strcmp ("frmptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->frmptr);
		FOUT
		}
	if (strcmp ("delay_dist_ptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->delay_dist_ptr);
		FOUT
		}
	if (strcmp ("busy_dist_ptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->busy_dist_ptr);
		FOUT
		}
	if (strcmp ("monitor_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->monitor_id);
		FOUT
		}
	if (strcmp ("node_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->node_id);
		FOUT
		}
	if (strcmp ("blk_counter" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->blk_counter);
		FOUT
		}
	if (strcmp ("frame_sent" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->frame_sent);
		FOUT
		}
	if (strcmp ("income_frm_count_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->income_frm_count_stathandle);
		FOUT
		}
	if (strcmp ("income_frm_count" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->income_frm_count);
		FOUT
		}
	if (strcmp ("output_frm_count_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->output_frm_count_stathandle);
		FOUT
		}
	if (strcmp ("output_frm_count" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->output_frm_count);
		FOUT
		}
	if (strcmp ("bk_count" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->bk_count);
		FOUT
		}
	if (strcmp ("next_state" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->next_state);
		FOUT
		}
	if (strcmp ("burst_size" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->burst_size);
		FOUT
		}
	if (strcmp ("next_pos" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->next_pos);
		FOUT
		}
	if (strcmp ("burst_size_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->burst_size_stathandle);
		FOUT
		}
	if (strcmp ("decode" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->decode);
		FOUT
		}
	if (strcmp ("seg_buf_ptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->seg_buf_ptr);
		FOUT
		}
	if (strcmp ("frame_label" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->frame_label);
		FOUT
		}
	if (strcmp ("seg_buf_size" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->seg_buf_size);
		FOUT
		}
	if (strcmp ("blk_ptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->blk_ptr);
		FOUT
		}
	if (strcmp ("blk_size" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->blk_size);
		FOUT
		}
	if (strcmp ("first_frame" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->first_frame);
		FOUT
		}
	if (strcmp ("blocks_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->blocks_stathandle);
		FOUT
		}
	if (strcmp ("frm_cnt_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->frm_cnt_stathandle);
		FOUT
		}
	if (strcmp ("tot_frm_cnt" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->tot_frm_cnt);
		FOUT
		}
	if (strcmp ("sent_size" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->sent_size);
		FOUT
		}
	if (strcmp ("blks_sent" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->blks_sent);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

