/* Process model C form file: cdpd_trc_drvn_agg.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char cdpd_trc_drvn_agg_pr_c [] = "MIL_3_Tfile_Hdr_ 90A 30A opnet 7 3E4081D7 3E4081D7 1 zeus saviol 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                            ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#include "string.h"
#include "stdlib.h"
#include "stdio.h"
#include "math.h"
/*Packet stream definitions */
#define SRC_OUT_STRM	0
#define SEND			(op_intrpt_type()== OPC_INTRPT_SELF)
/*extern FILE	*fp;*/

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	List*	                  		line_list_ptr;
	List*	                  		field_list_ptr;
	int	                    		line_index;
	int	                    		list_size;
	int	                    		line_counter;
	Objid	                  		my_id;
	double	                 		offset;
	int	                    		assigned_tei;
	int	                    		rate;
	double	                 		previous_time;
	int	                    		frm_tei;
	int	                    		previous_tei;
	int	                    		frm_size;
	double	                 		read_time;
	} cdpd_trc_drvn_agg_state;

#define pr_state_ptr            		((cdpd_trc_drvn_agg_state*) SimI_Mod_State_Ptr)
#define line_list_ptr           		pr_state_ptr->line_list_ptr
#define field_list_ptr          		pr_state_ptr->field_list_ptr
#define line_index              		pr_state_ptr->line_index
#define list_size               		pr_state_ptr->list_size
#define line_counter            		pr_state_ptr->line_counter
#define my_id                   		pr_state_ptr->my_id
#define offset                  		pr_state_ptr->offset
#define assigned_tei            		pr_state_ptr->assigned_tei
#define rate                    		pr_state_ptr->rate
#define previous_time           		pr_state_ptr->previous_time
#define frm_tei                 		pr_state_ptr->frm_tei
#define previous_tei            		pr_state_ptr->previous_tei
#define frm_size                		pr_state_ptr->frm_size
#define read_time               		pr_state_ptr->read_time

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	cdpd_trc_drvn_agg_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void cdpd_trc_drvn_agg (void);
	Compcode cdpd_trc_drvn_agg_init (void **);
	void cdpd_trc_drvn_agg_diag (void);
	void cdpd_trc_drvn_agg_terminate (void);
	void cdpd_trc_drvn_agg_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
cdpd_trc_drvn_agg (void)
	{
	int _block_origin = 0;
	FIN (cdpd_trc_drvn_agg ());
	if (1)
		{
		char    *file_name;
		int 	i;
		double	send_time;
		double	time_diff;
		char	err_str[256];
		Packet	*frm_ptr;


		FSM_ENTER (cdpd_trc_drvn_agg)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (Init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "Init", "cdpd_trc_drvn_agg [Init enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_trc_drvn_agg [Init enter execs]", state0_enter_exec)
				{
				line_counter=1;
				
				/*- "script" file  should be obtained from the 'trace'-*/
				my_id = op_id_self ();
				op_ima_obj_attr_get (my_id, "Time Offset", &offset);
				op_ima_obj_attr_get (my_id, "M-ES TEI", &assigned_tei);
				op_ima_obj_attr_get (my_id, "Upper Layer Rate", &rate);
									 
				file_name="sierra"; 
				
				/*-Start from the first line-*/		
				line_index=0;			
				frm_size=2000;
				send_time=0;
				
				/*------Read The Script File into a list of strings---*/
				line_list_ptr=op_prg_gdf_read (file_name);
				
				if (line_list_ptr == OPC_NIL)	/*-Failed in reading the file-*/
				{
					sprintf(err_str, "File Name: %s", file_name);
					op_sim_end ("err: cannot load file",err_str,"","");
				}
				list_size = op_prg_list_size (line_list_ptr);
				
				
				/*-------Decomposite the first line of the file into a list of fields---*/
				field_list_ptr=op_prg_str_decomp(op_prg_list_access(line_list_ptr, line_index), " ,/\t");
				line_index++;
				
				/*-------Get the time at which the first packet should be generated----*/
				read_time=(double)atof(op_prg_list_access(field_list_ptr, 0));
				send_time = read_time;
				previous_time=send_time;
				frm_tei=atoi(op_prg_list_access(field_list_ptr,2));
				frm_size=atoi(op_prg_list_access(field_list_ptr,1));
				frm_size=frm_size*8;
				previous_tei=frm_tei;
				if(send_time< op_sim_time())
					send_time=op_sim_time();
				
				/*-------Schedule a self interrupt --------*/
				op_intrpt_schedule_self(send_time,0);
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_trc_drvn_agg [Init enter execs]", state0_enter_exec)

			/** state (Init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "Init", "cdpd_trc_drvn_agg [Init exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_trc_drvn_agg [Init exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_trc_drvn_agg [Init exit execs]", state0_exit_exec)


			/** state (Init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "Init", "Idle")
				/*---------------------------------------------------------*/



			/** state (Idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "Idle", "cdpd_trc_drvn_agg [Idle enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_trc_drvn_agg [Idle enter execs]", state1_enter_exec)
				{
				
				}

				FSM_PROFILE_SECTION_OUT ("cdpd_trc_drvn_agg [Idle enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,cdpd_trc_drvn_agg)


			/** state (Idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "Idle", "cdpd_trc_drvn_agg [Idle exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_trc_drvn_agg [Idle exit execs]", state1_exit_exec)
				{
				if (op_intrpt_type ()== OPC_INTRPT_SELF && line_counter< list_size)
				{
				
					/*-Get the size of the packet to be generated if the TEI matches-*/
					if (frm_tei == assigned_tei)
					{
						/*--Create a packet with the packet size 'pk_size'-*/
						frm_ptr=op_pk_create(frm_size);
				
				
						/*--Send the packet through the out going stream---*/
						op_pk_send(frm_ptr, SRC_OUT_STRM);
					}
				
					/*-------Decomposite the next line of the file into a list of fields---*/
					op_prg_list_free(field_list_ptr);
					field_list_ptr=op_prg_str_decomp(op_prg_list_access(line_list_ptr,line_index), " ,/\t");
					line_index++;
				
				
					/*-------Get the time at which the next packet should be generated----*/
					send_time=(double)atof(op_prg_list_access(field_list_ptr,0));
					frm_tei=atoi(op_prg_list_access(field_list_ptr,2));
					frm_size=atoi(op_prg_list_access(field_list_ptr,1));
					frm_size=frm_size*8;
				
					if (frm_tei == assigned_tei) // modify the send time if the TEI matches
					{
						if (previous_tei != frm_tei) /* first packet in a burst */
						{
							time_diff = send_time - previous_time;
							time_diff = offset * time_diff;
							read_time = send_time;
							send_time = previous_time + time_diff;
						}
						else if (previous_tei == frm_tei) /* subsequent packets from the same M-ES */
						{
							if ((frm_size/(send_time-read_time)) > 11000) 
							{
								/* a continuous burst is considered only if the rate is greater then 10kbps */
								read_time = send_time;
					 			send_time = previous_time + (frm_size / rate);
							}
							else
							{
				 				/* not the same burst - treat it like the first packet in a burst */
					  			time_diff = send_time - previous_time;
								time_diff = offset * time_diff;
								read_time = send_time;
								send_time = previous_time + time_diff;
							}
				
						}
					}
					previous_tei=frm_tei;
					previous_time=send_time;
					if(send_time<op_sim_time())
						send_time=op_sim_time();
				
				
					/*-------Schedule a self interrupt --------*/
					op_intrpt_schedule_self(send_time,0);
					line_counter++;
				}
				}
				FSM_PROFILE_SECTION_OUT ("cdpd_trc_drvn_agg [Idle exit execs]", state1_exit_exec)


			/** state (Idle) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "Idle", "Idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,cdpd_trc_drvn_agg)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
cdpd_trc_drvn_agg_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (cdpd_trc_drvn_agg_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (cdpd_trc_drvn_agg)",
			sizeof (cdpd_trc_drvn_agg_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((cdpd_trc_drvn_agg_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
cdpd_trc_drvn_agg_diag (void)
	{
	/* No Diagnostic Block */
	}




void
cdpd_trc_drvn_agg_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (cdpd_trc_drvn_agg_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in cdpd_trc_drvn_agg_svar function. */
#undef line_list_ptr
#undef field_list_ptr
#undef line_index
#undef list_size
#undef line_counter
#undef my_id
#undef offset
#undef assigned_tei
#undef rate
#undef previous_time
#undef frm_tei
#undef previous_tei
#undef frm_size
#undef read_time



void
cdpd_trc_drvn_agg_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	cdpd_trc_drvn_agg_state		*prs_ptr;

	FIN (cdpd_trc_drvn_agg_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT
		}
	prs_ptr = (cdpd_trc_drvn_agg_state *)gen_ptr;

	if (strcmp ("line_list_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->line_list_ptr);
		FOUT
		}
	if (strcmp ("field_list_ptr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->field_list_ptr);
		FOUT
		}
	if (strcmp ("line_index" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->line_index);
		FOUT
		}
	if (strcmp ("list_size" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->list_size);
		FOUT
		}
	if (strcmp ("line_counter" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->line_counter);
		FOUT
		}
	if (strcmp ("my_id" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->my_id);
		FOUT
		}
	if (strcmp ("offset" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->offset);
		FOUT
		}
	if (strcmp ("assigned_tei" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->assigned_tei);
		FOUT
		}
	if (strcmp ("rate" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->rate);
		FOUT
		}
	if (strcmp ("previous_time" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->previous_time);
		FOUT
		}
	if (strcmp ("frm_tei" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->frm_tei);
		FOUT
		}
	if (strcmp ("previous_tei" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->previous_tei);
		FOUT
		}
	if (strcmp ("frm_size" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->frm_size);
		FOUT
		}
	if (strcmp ("read_time" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->read_time);
		FOUT
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

